; ///////////////////
; // Tarot 
; // ver 1.0
; // by Eikon
; // Last modified 02.15.06
; ///////////////////

Global Parent, winPanel = 0, winZoom = 0, winTool, Canvas, Panel, Shuffle, Spread, sCombo, winDeck = 0, bDeckOK
Global mnuMax, mnuNum, TableCol1 = 0, TableCol2 = 64, TableCol3 = 128, cfgCardNum = True, cfgCardCnt = True, cfgNotes$
Global mnuInfo, mnuLarge, mnuSmall, mnuRev, CardWinX%, CardWinY%, CardWinW%, CardWinH%, winHome = 0
Global gadBrowse, btnHome, btnFor, btnBack, botPage% = 1, btnNextP, btnPrevP, winNotes = 0, NoteArea

; Menu
Const cntEXIT = 1, cntMAX = 2, cntNUM = 3, cntSHUF = 4, cntDECK = 5, cntCNT = 6, cntSMALL = 7, cntREV = 8
Const cntCP = 9, cntBOOK = 10, cntABOUT = 11, cntNOTE = 12, cntBACK = 13, cntINSTR = 14, cntLARGE = 15, cntHOME = 16

TFormFilter 1

LoadGUI 1 ; Parent

Type Card
	Field X%, Y%, D%, N%, RC%, F%, REV%, Drag%
End Type

Global iBack, DeckNumber% = 6

LoadCFG
ChangeDeck DeckNumber%

Local DragX%, DragY%
Global bDrag = False, MH1 = False, MH2 = False
Global DeckSize% = 78, TableSize% = 0, xScr% = 0, yScr% = 0
Global zCanvas, DeckOX%, DeckOY%, zWinCount% = 0

Dim DeckNum(78)
Dim BackPanel(14), zWin(78)

AutoSuspend 1
SeedRnd MilliSecs(): ShuffleDeck
CreateTimer 60 ; 60 FPS
Repeat

Select WaitEvent()	
	Case $803
	For i = 0 To 77
		If EventSource() = zWin(i) Then
			CardWinX = GadgetX(zWin(i)): CardWinY = GadgetY(zWin(i))
			CardWinW = GadgetWidth(zWin(i)): CardWinH = GadgetHeight(zWin(i))
			FreeGadget zWin(i): zWin(i) = 0 ; Exit zoom					
		EndIf
		
		If EventSource() = winHome Then
			btnNextP = 0
			btnPrevP = 0
			btnBack = 0
			btnFor = 0
			btnHome = 0
		EndIf
		
		If EventSource() = winDeck Then	bDeckOK = 0
	Next
	
	Select EventSource()
		Case Parent
		SaveCFG
		FreeGadget Parent: End    ; Exit main
			
		Case winPanel             ; Exit Controls
		FreeGadget winPanel: winPanel = 0
		
		Case winDeck: FreeGadget winDeck: winDeck = 0 ; Exit Deck
		
		Case winHome ; Exit Browser
		FreeGadget winHome: winHome = 0 
		
		Case winNotes ; Notes
		cfgNotes$ = TextAreaText(NoteArea)
		FreeGadget winNotes: winNotes = 0
		
	End Select
	
	Case $201
	If winDeck <> 0 Then
		For i = 0 To 14
			If EventSource() = BackPanel(i) Then
				ChangeDeck i + 1
				DeckNumber = i + 1
			EndIf
		Next
	EndIf

	Case $1001 ; Menu Events
	Select EventData()
		Case cntMAX ; Maximize
		If MenuChecked(mnuMax) = True Then ; Win
			FreeGadget Canvas
			Desk_W = ClientWidth(Desktop()): Desk_H = ClientHeight(Desktop()): xScr = oldxScr: yScr = oldyScr
			SetWindowPos QueryObject(Parent, 1), 0, Desk_W / 2 - 325, Desk_H / 2 - 264, 638, 526, 4 + 64
			Panel = CreatePanel(0, 0, 644, 484, Parent, -1)
			Canvas = CreateCanvas(0, 0, 640, 480, Panel)
			ClsColor TableCol1, TableCol2, TableCol3: SetBuffer CanvasBuffer(Canvas) 
			UncheckMenu mnuMax
		Else                               ; Full
			FreeGadget Panel: oldxScr = xScr: oldyScr = yScr: xScr = 0: yScr = 0
			SetWindowPos QueryObject(Parent, 1), 0, 0, 0, ClientWidth(Desktop()), ClientHeight(Desktop()) - 28, 4 + 64
			Canvas = CreateCanvas(0, 0, GadgetWidth(Parent) - 6, GadgetHeight(Parent) - 44, Parent)
			SetBuffer CanvasBuffer(Canvas): ClsColor TableCol1, TableCol2, TableCol3
			CheckMenu mnuMax
		EndIf
		UpdateWindowMenu Parent
	
		Case cntNUM ; Card Number
		If MenuChecked(mnuNum) Then
			UncheckMenu mnuNum: cfgCardNum = False
		Else
			CheckMenu mnuNum: cfgCardNum = True
		EndIf
		UpdateWindowMenu Parent
		
		Case cntBOOK  ; Book of Thoth
		If winHome = 0 Then LoadGUI 6
			
		Case cntHOME ; Home
		If winHome = 0 Then LoadGUI 5
		
		Case cntNOTE ; Notes
		If winNotes = 0 Then LoadGUI 7
			
		Case cntCNT ; Card Count
		If MenuChecked(mnuInfo) Then
			UncheckMenu mnuInfo: cfgCardCnt = False
		Else
			CheckMenu mnuInfo: cfgCardCnt = True
		EndIf
		UpdateWindowMenu Parent
		
		Case cntCP ; Control Panel
		Delete Each Card
		DeckSize = 78: TableSize = 0
		ShuffleDeck()
	
		Case cntREV  ; Reversals
		If MenuChecked(mnuRev) Then
			UncheckMenu mnuRev
		Else
			CheckMenu mnuRev
		EndIf
		UpdateWindowMenu Parent
		
		Case cntBACK ; Table
		tmp = RequestColor(TableCol1, TableCol2, TableCol3)
		If tmp <> 0 Then 
			TableCol1 = RequestedRed(): TableCol2 = RequestedGreen(): TableCol3 = RequestedBlue()
			ClsColor TableCol1, TableCol2, TableCol3
		EndIf
					
		Case cntEXIT ; Exit
		SaveCFG: FreeGadget Parent: End

		Case cntDECK ; Deck
		LoadGUI 4
		
		Case cntLARGE ; Large Card Size
		If Not MenuChecked(mnuLarge) Then
			UncheckMenu mnuSmall: CheckMenu mnuLarge
			UpdateWindowMenu Parent
			ChangeDeck DeckNumber: DeckOX = 100: DeckOY = 150
		EndIf
		
		Case cntSMALL ; Small Card Size
		If Not MenuChecked(mnuSmall) Then
			ResizeImage iBack, 71, 96: DeckOX = 82: DeckOY = 106
			UncheckMenu mnuLarge: CheckMenu mnuSmall
			UpdateWindowMenu Parent
		EndIf

		Case cntABOUT ; About
		Notify "Tarot" + Chr$(10) + "ver. 1.0" + Chr$(10) + "by Eikon" + Chr$(10) + Chr$(10) + "Card Design and Game rights" + Chr$(10) + "belong to Aleister Crowley" + Chr$(10) + "and Lady Frieda Harris"
		
		Case cntINSTR ; Instructions
		Notify "1) Click and drag a card from the deck to place it on the table" + Chr$(10) + "2) Right click a card on the table to flip it" + Chr$(10) + "3) Right click a flipped card to zoom in and read it's description" + Chr$(10) + Chr$(10) + "If the game window isn't maximized you may use the arrow keys to move around the table"
		
	End Select
	
	Case $401  ; GadgetEvent
	Select EventSource()
		
		Case Shuffle
		DeckSize% = 78: TableSize% = 0:	oldCards$ = ""
		Delete Each Card: ShuffleDeck
		
		Case btnPrevP ; Previous Page
		If botPage > 1 Then 
			botPage = botPage - 1
			HtmlViewGo gadBrowse, CurrentDir$() + "htm/page" + Str(botPage) + ".htm"
			SetStatusText winHome, " Book of Thoth page " + botPage
		EndIf
		
		Case btnNextP ; Next Page
		If botPage < 6 Then 
			botPage = botPage + 1
			HtmlViewGo gadBrowse, CurrentDir$() + "htm/page" + Str(botPage) + ".htm"
			SetStatusText winHome, " Book of Thoth page " + botPage
		EndIf
		
		Case btnBack
		HtmlViewBack gadBrowse ; Back
		
		Case btnFor
		HtmlViewForward gadBrowse ; Forward
		
		Case btnHome
		HtmlViewGo gadBrowse, "http://www.eiksoft.com": botPage = 0 ; Home
		SetGadgetShape winHome, 0, 0, ClientWidth(Desktop()), ClientHeight(Desktop())

		Case bDeckOK
		FreeGadget winDeck
		winDeck = 0
	
	End Select
	
	Case $1001 ; Menu Event
	If EventData() = cntEXIT Then FreeGadget Parent: End
	
	Case $4001 ; Tick
	Cls
	MH1 = MouseHit(1): MH2 = MouseHit(2)
	
	For c.Card = Each Card
		If c\D = 0 Then 
			;If c\Drag = 1 Then
				DrawImage iBack, c\X - xScr, c\Y - yScr				
			;Else
			;	DrawImage iBack, MouseX(Canvas), MouseY(Canvas)
			;EndIf
			
			If cfgCardNum = True Then ; Display Card Number
				If Len(c\N + 1) = 2 Then tmp = 27 Else tmp = 31
				If MenuChecked(mnuLarge) Then tmp = tmp + 9
				Color 0, 0, 0: Rect ((c\X + tmp) - 1) - xScr, (c\Y + 3) - yScr, Len(Str(c\N + 1)) * 12, 14, 1
				Color 255, 255, 255: Text (c\X + tmp) - xScr, (c\Y + 3) - yScr, c\N + 1
			EndIf
		Else
			DrawImage c\RC, c\X - xScr, c\Y - yScr
		EndIf

		If MH2 = True Then CheckCard()
	Next
	
	If DeckSize <> 0 Then
		Color 255, 255, 255
		If MenuChecked(mnuLarge) Then ; Big Deck
			Rect ClientWidth(Canvas) - DeckOX - 1, ClientHeight(Canvas) - DeckOY - 1, 91, 142, 1 
		Else
			Rect ClientWidth(Canvas) - DeckOX - 1, ClientHeight(Canvas) - DeckOY - 1, 73, 98, 1 
		EndIf
		DrawImage iBack, ClientWidth(Canvas) - DeckOX, ClientHeight(Canvas) - DeckOY
	EndIf
	
	If bDrag = True Then ; User is placing a card
		DrawImage iBack, MouseX(Canvas) - DragX, MouseY(Canvas) - DragY
	EndIf
	
	If MenuChecked(mnuInfo) = True Then ; Display Card Count
		Color 255, 255, 255: Text 5, ClientHeight(Canvas) - 36, "Deck (" + DeckSize + ")"
		Text 5, ClientHeight(Canvas) - 20, "Table (" + TableSize + ")"
		Text 5, ClientHeight(Canvas) - 52, (TotalVidMem() - AvailVidMem()) / 1024 + "kbs"
		Text 5, ClientHeight(Canvas) - 68, xScr + ", " + yScr
	EndIf
	
	If KeyHit(1) Then 
		SaveCFG
		FreeGadget Parent: End
	EndIf
	
	If Not MenuChecked(mnuMax) Then
		If KeyDown(203) Then
			If xScr > 0 Then xScr = xScr - 5 ; Left
		EndIf
		If KeyDown(205) Then
			If xScr < ClientWidth(Desktop()) - 650 Then xScr = xScr + 5 ; Right
		EndIf
		If KeyDown(200) Then
			If yScr > 0 Then yScr = yScr - 5
		EndIf
		If KeyDown(208) Then
			If yScr < ClientHeight(Desktop()) - 556 Then yScr =yScr + 5
		EndIf
	EndIf

	If MouseDown(1) Then
		If bDrag = False And DeckSize > 0 Then ; Deck Drag
			If ImageRectCollide(iBack, ClientWidth(Canvas) - DeckOX, ClientHeight(Canvas) - DeckOY, 0, MouseX(Canvas), MouseY(Canvas), 1, 1) Then
				bDrag = True: DragX = MouseX(Canvas) - (ClientWidth(Canvas) - DeckOX): DragY = MouseY(Canvas) - (ClientHeight(Canvas) - DeckOY)
			EndIf
		EndIf
	Else
		If bDrag = True Then
			If ImagesCollide(iBack, ClientWidth(Canvas) - DeckOX, ClientHeight(Canvas) - DeckOY, 0, iBack, MouseX(Canvas) - DragX, MouseY(Canvas) - DragY, 0) Then ; Cancel Drop
				bDrag = False
			Else ; Place a card
				bDrag = False: DeckSize = DeckSize - 1
				c.Card = New Card
				tmp = DeckNum(TableSize): c\F = tmp
				c\X = (MouseX(Canvas) - DragX) + xScr: c\Y = (MouseY(Canvas) - DragY) + yScr			
				c\N = TableSize: c\D = 0: c\Drag = 0
				TableSize = TableSize + 1
			EndIf
		EndIf			
	EndIf			
			
	VWait 1: FlipCanvas Canvas, 0
	
End Select
	
Forever

Function LoadWindow(num, frame, rev)
itmp = LoadImage("gfx/" + frame + ".jpg"): MaskImage itmp, 255, 0, 255

;tmp$ = " (" + frame + ") "
tmp$ = "": desc$ = "": astro$ = "": hebrew$ = "": desc2$ = ""
Select frame
; //===============================================================================================
; // MAJOR ARCANA (TRUMPS)
; //===============================================================================================
	Case 0 ; The Fool
	tmp$ = "The Fool": astro$ = "Air": hebrew$ = "Aleph"
	desc$ = "In spiritual matters, represents ideas, thoughts, spirituality, that which endeavors to transcend earth. In material matters may show, if ill-dignified, folly, eccentricity, even mania. If represents the original, subtle, sudden impulse coming from a strange and unexpected quarter."
	desc2$ = "The Fool is Air, Emptiness, also Potential Purity. He holds the Wand of Fire, the Cup of Water, the Sword of Air, and the bag of planetary Disks. Round him is the rainbow issuing from the returning to his heart, he wears the fool's cap, the horns of Bacchus, he stands on Harpocrates, the Egyptian symbol of adolescent Fertility, he is unconscious of the tiger tearing at his side, he is the Green Man of the Celts, Duluah and Parsival. This is the moment of divine consciousness."

	Case 1 ; The Magus
	tmp$ = "The Magus": astro$ = "Mercury": hebrew$ = "Beth"
	desc$ = "Skill. Wisdom. Adroitness. Elasticity. Craft. Cunning. Deceit. Theft. Sometimes occult wisdom or power. Messages. Business transactions. Ill-dignified: Learning or intelligence interfering with the matter in hand."
	desc2$ = "He is Mercury, the messenger of God, and juggles with the four symbols of the elements, and the papyrus or Word, the pen or Will, the Wand or Wisdom. He represents the creative force in action. As Thoth in Egyptian tradition, his attendant and shadow is the Cynocephalus Ape."

	Case 2 ; The Priestess
	tmp$ = tmp$ + "The Priestess": astro$ = "The Moon": hebrew$ = "Gimet"
	desc$ = "Pure, exalted and gracious influence enters the matter, hence change, alteration, increase and decrease, fluctuation. May be led away by enthusiasm unless careful balance maintained."
	desc2$ = "She is a spiritual Isis and a virgin Artemis. With her veil of light, she is weaving the crystals and fruits of the Earth. She carries the huntress' bow and the musical sistrum."
	
	Case 3 ; The Empress
	tmp$ = tmp$ + "The Empress": astro$ = "Venus": hebrew$ = "Daleth"
	desc$ = "Love. Beauty. Happiness. Pleasure. Success. Fruitfulness. Good fortune. Graciousness. Elegance. Gentleness. Ill-dignified: Dissipation. Debauchery. Idleness. Sensuality."
	desc2$ = "The Empress is seated in the traditional posture symbolizing alchemical Salt. This is a woman in her all-embracing receptivity, incarnate womanhood, holding the lotus, wearing the belt of the Zodiac, surrounded by her Venus birds, the pelican of self-surrender and the heraldic white eagle of salt."
	
	Case 4 ; The Emperor
	tmp$ = tmp$ + "The Emperor": astro$ = "Aries": hebrew$ = "Tzaddi"
	desc$ = "War. Conquest. Victory. Strife. Stability. Power. Originality. Government. Energy. Ambition. Ill-dignified: Overweening pride. Megalomania. Rashness. Ill-temper."
	desc2$ = "Again he is seated according to tradition. His legs from a right angle, typifying rule through unyielding law and order. The goats behind him show he is governed by Aries, creative dominating force. The bees on his costume may have originated from French tradition, but more probably they typify the bees of the Secret Doctrines in the Indian Upanishads. The heraldic red eagle is the fiery sulphur of Alchemy. The lamb is, possibly, a reminiscence of the Knights Templar."
	
	Case 5 ; The Hierophant
	tmp$ = tmp$ + "The Hierophant": astro$ = "Taurus": hebrew$ = "Vau"
	desc$ = "Divine wisdom. Inspiration. Stubborn strength. Toil. Endurance. Persistence. Teaching. Help from superiors. Patience. Organization. Peace. Goodness of heart. Occult force voluntarily invoked."
	desc2$ = "The Hierophant is seated on his governing sign Taurus, the elephants are the indian form of the same. The pentagram with a point upwards and the dancing child shows that he has the heart of a child; in the reversed pentagram the meaning seems to suggest he has dominion through will; the final pentagram again points upwards, showing his acceptance of a governing cosmic law. The four masks are the Cherubim, man, eagle, lion, and bull. His votary the woman, stands with her sword pointing downwards signifying, perhaps, that woman in the future will draw fresh wisdom by the use of her subconscious."
	
	Case 6 ; The Lovers
	tmp$ = tmp$ + "The Lovers": astro$ = "Gemeni": hebrew$ = "Zain"
	desc$ = "Openness to inspiration. Intuition. Intelligence. Childishness. Attraction. Beauty. Love. Ill-dignified: Self-contradiction. Instability. Indecision. Union in a shallow degree with others. Superficiality."
	desc2$ = "This is an alchemical card illustrating the marriage or union of two opposites, thus we have the prince and princess holding the wand and the cup. Cain and Abel, Lilith and Eve. The swords at the back suggest the intellectual process in the uniting of two elements. The figure of the Creator blesses this deliberate synthesis. The alchemical white eagle of salt and the red eagle of sulphur, the Egg of wisdom and the winged wand of Osiris at the bottom of the card."
	
	Case 7 ; The Chariot
	tmp$ = tmp$ + "The Chariot": astro$ = "Cancer": hebrew$ = "Cheth"
	desc$ = "Triumph. Victory. Hope. Obedience. Faithfulness. Health. Success, though sometimes not enduring. Authority under authority. Ill-dignified: Violence in maintaining traditional ideas. Lust of destruction."
	desc2$ = "Held by the charioteer is the Cup of Indian, Egyptian and Arthurian tradition and it contains the blood of voluntary sacrifice. The charioteer (spirit) is seated in the chariot of the body and is drawn by sphinxes, who represent the sixteen sub elements of the emotions.
		
	Case 8 ; Adjustment
	tmp$ = tmp$ + "Adjustment": astro$ = "Libra": hebrew$ = "Lamed"
	desc$ = "Justice. Balance. Adjustment. Suspension of action pending decision. May refer to lawsuits, trials, marriages, treaties, etc."
	desc2$ = "Traditionally called Justice, the new name is a literal translation of the French " + Chr$(34) + "Justesse" + Chr$(34) + ", that is Equilibrium. She is balancing from the headdress of Isis the scales in which are the bubbles of Maya, illusion, typifying the transitory quality of human justice. The whole picture represents balance by opposites. The diamond patterning foreshadows the balancing Harlequin of the Commedia del l'Arte. 
	
	Case 9 ; The Hermit
	tmp$ = tmp$ + "The Hermit": astro$ = "Virgo": hebrew$ = "Yod"
	desc$ = "Illumination from within. Divine inspiration. Wisdom. Prudence. Circumspection. Retirement from participation in current events."
	desc2$ = "Here we have, in the hand of the Hermit, the Lamp of Sacred Wisdom. It contains the Sun which is hidden beneath. The surrounding darkness to fructify the earth. The Hermit is looking at the Egg (Universe) which is surrounded by the snake, a symbol of life. The hounds of hell endeavour to snatch the sacred light and the little Homunculus. The wheat is in the masonic tradition."
	
	Case 10 ; Fortune
	tmp$ = tmp$ + "Fortune": astro$ = "Jupiter": hebrew$ = "Kaph"
	desc$ = "Change of fortune, generally good. Destiny."
	desc2$ = "On the Wheel of Fortune at the top of the card is the Sphinx meaning intelligence and balance. On the left is Hermanubis the Ape who is unstable brilliant reason. At the bottom of the wheel is typhon who expresses ignorance and sluggishness. Here we have the implication to be found on all these cards of possible regeneration in all circumstances, for Typhon holds the Ankh of salvation with one hand and the other the hook with which he snatches the soul. The eclipse of stars at the top of the card generates in forked lines the circle of the wheel."
	
	Case 11 ; Lust
	tmp$ = tmp$ + "Lust": astro$ = "Leo": hebrew$ = "Teth"
	desc$ = "Courage. Strength. Energy. Use of magical power. Control of the life force. Great love affair. Resort to magic."
	desc2$ = "This card was called Strength. It means joy in desire. The lion has seven heads, an angel, a saint, a poet, a warrior, a bacchante, a satyr, and a lion-serpent. The woman has given herself to the forces of life. She holds the Cup of impregnated womb. The horns surrounding it represent the male element. The figures under the feet of the lion are the martyrs to whom this path towards Union is an empty dream. The reins which are held by the woman are the passion which unites her to the Beast."
	
	Case 12 ; Hanged Man
	tmp$ = tmp$ + "The Hanged Man": astro$ = "Water": hebrew$ = "Mem"
	desc$ = "Redemption through sacrifice. Enforced sacrifice. Suffering. Ill-dignified: Punishment. Loss. Defeat. Failure. Death."
	desc2$ = "This figure is Osiris or Christ and shows redemption through suffering. He is drowned in the waters of affliction. The attitude is traditional and involves a right angle and a triangle. His foot is bound to the Ankh of Immortality by the serpent of life. The complete symbol is a triangle and a cross."
	
	Case 13; Death
	tmp$ = tmp$ + "Death": astro$ = "Scorpio": hebrew$ = "Non"
	desc$ = "Transformation. Change voluntary or involuntary, perhaps sudden and unexpected. Apparent death or destruction that is illusory when viewed from a higher perspective."
	desc2$ = "This card means redemption through putrefaction, the seed in the ground decays, but rises again to new life. Death, crowned with the headdress of Osiris, is raising from the scythe the reincarnating bubbles of life. Behind him is the eagle, symbol of immortality, and below him are the embryonic amoeba."
	
	Case 14 ; Art
	tmp$ = tmp$ + "Art": astro$ = "Sagittarius": hebrew$ = "Samech"
	desc$ = "Combination of forces. Realization. Action based on accurate calculation. Economy. Management. Success after elaborate maneuvers. The way of escape."
	desc2$ = "This is the second alchemical card, in which the Lovers are united in an androgyne figure, the Prince becoming white and the Princess black, the red lion white, the white eagle red and the cup is lightning the torch. There is a crucible engraved with a raven standing on a skull which holds the seething elements whose iridescent bubbles are reflected by the rainbow overhead. All these typify the destruction of two elements at the birth of a third. The inscription on the rainbow is the alchemical mandate " + Chr$(34) + "Visita interiora terrae rectificando invenies occultem lapidem." + Chr$(34)
	
	Case 15 ; The Devil
	tmp$ = tmp$ + "The Devil": astro$ = "Capricornus": hebrew$ = "Ain"
	desc$ = "Blind impulse. Irresistibly strong and unscrupulous person. Ambition. Temptation. Obsession. Secret plan about to be executed. Hard work. Endurance. Aching discontent. Materialism. Fate."
	desc2$ = "As this card is governed by Capricornus, we have the traditional goat. On his forehead is the Eye of God, his curved horns represent the spiral force in nature, that is wanton creation, and his abandonment is emphasized by the bacchanalian bunch of grapes. Beneath him are his votaries in two dividing cells, stressing the doctrine that all sin is division. The background is designed from the marking on the planet Mars. The Goat is supported on the Caduceus. At the top of the Tree of Life at the back of the card is the ring of Saturn."
	
	Case 16 ; The Tower
	tmp$ = tmp$ + "The Tower": astro$ = "Mars": hebrew$ = "Peh"
	desc$ = "Quarrel. Combat. Danger. Ruin. Destruction of plans. Ambition. Courage. Sudden death. Escape from prison and all it implies."
	desc2$ = "Here is the purification through fire, lightning, flames, war. The open mouth at the base of the card alludes to the Hebrew attribution Peh meaning a mouth, the eye is the eye of Shiva. The card is designed on the form of a carbon crystal, the figures falling from the tower are made of carbon, the serpent on the right is the symbol of the active will to live, the dove on the left is passive resignation to death."
	
	Case 17 ; The Star
	tmp$ = tmp$ + "The Star": astro$ = "": hebrew$ = ""
	desc$ = "Hope. Unexpected help. Clarity of vision. Spiritual insight. Ill-dignified: Error of judgement. Dreaminess. Disappointment."
	desc2$ = "This is built up as a design on a spiral to show the rising force of a new age. The woman holds two cups, the north and south poles of magnetic attraction. Above her a new star is rising, beneath her are the crystallizing dogmas of a former Age."
	
	Case 18 ; The Moon
	tmp$ = tmp$ + "The Moon": astro$ = "Pisces": hebrew$ = "Koph"
	desc$ = "Illusion. Deception. Bewilderment. Hysteria. Madness. Dreaminess. Falsehood. Voluntary change. The brink of an important change. This card is very sensitive to dignity."
	desc2$ = "This is the most sinister card. Through sorcery and witchcraft it is possible to get an understanding of the universe, but the path is dangerous. On each side of the picture are dark fortresses; the Anubis, the gods of death, are ready to seize the soul of the aspirant and jackals wait to devour those who have fallen by the way. The Sun is held by the Scarabeus Sacer under the water. The design on the card is planned on the movement of the tide whose ebb and flow is governed by the Moon."

	Case 19 ; The Sun
	tmp$ = tmp$ + "The Sun": astro$ = "Sun": hebrew$ = "Resh"
	desc$ = "Glory. Gain. Riches. Triumph. Pleasure. Frankness. Truth. Shamelessness. Manifestation. Recovery from sickness, but sometimes sudden death. Ill-dignified: Arrogance. Vanity."
	desc2$ = "This card shows the simple human approach to the mysteries. The Sun is the lord of life, liberty, light and love. The children are dancing with butterfly wings. They are surrounded by the signs of the Zodiac, showing the different houses through which the sun passes."

	Case 20 ; The Aeon
	tmp$ = tmp$ + "The Aeon": astro$ = "Fire": hebrew$ = "Shin"
	desc$ = "Final decision concerning the past. New current for the future. Always represents the taking of a definite step."
	desc2$ = "In the centre of the card is the child Horus, who is the incarnation of the New Age. His left hand is open, signifying that the old universe has been destroyed and he is too young to formulate a new one. He is surrounded by the figure of Nuit, the Star goddess, and beneath him is the winged point Hadit."
	
	Case 21 ; The Universe
	tmp$ = tmp$ + "The Universe": astro$ = "Saturn. Earth": hebrew$ = "Tau"
	desc$ = "The essence of the question itself. Synthesis. The end of the matter. Delay. Opposition. Inertia. Perseverance. Patience. The crystallization of the whole matter involved."
	desc2$ = "The universe is represented as a maiden dancing with a great spiral serpent. She holds the Moon in her hand and the Sun is merged in the Eye of God. These two planets typify the positive and negative forces. Behind her is a geometrical solid by Moebius. Around her are all the stars of the Zodiac, the curved seventy-two lines stand for the quinaries and are also an attempt to convey movement and to give the fourth dimension of time. Beneath her is Sullivan's map of chemical elements. At the four corners are the Cherubim or Winds of Heaven, the bull, the lion, the eagle and the man."
	
; //===============================================================================================
; // MINOR ARCANA
; //===============================================================================================
; // WANDS
; //===============================================================================================
	Case 22 ; Ace of Wands
	tmp$ = tmp$ + "Ace of Wands": astro$ = "": hebrew$ = ""
	desc$ = "The Root of the Powers of Fire. Energy. Strength. Force. Solar-phallic outburst of flame. Vigor. Natural force as opposed to invoked force."
	desc2$ = "The flames are the Hebrew letter Yod, and are arranged on the Tree of Life. This is the primal condition of the element of Fire."
	
	Case 23 ; Dominion
	tmp$ = tmp$ + "Two of Wands: Dominion": astro$ = "Mars in Aries": hebrew$ = "Chokmah"
	desc$ = "Fire in its highest form. Energy initiating a current of force. Harmony of rule and justice. Influence over another. Boldness. Courage. Fierceness. Ill-dignified: Restlessness. Turbulence. Obstinacy."
	desc2$ = "Two dorjes crossed, meaning destruction as a beginning of creation."
	
	Case 24 ; Virtue
	tmp$ = tmp$ + "Three of Wands: Virtue": astro$ = "Sun in Aries": hebrew$ = "Binah"
	desc$ = "Established strength. Success after struggle. Pride and arrogance. Realization of hope. Nobility. Ill-dignified: Conceit."
	desc2$ = "Three lotus wands representing creation."
	
	Case 25 ; Completion
	tmp$ = tmp$ + "Four of Wands: Completion": astro$ = "Venus in Aries": hebrew$ = "Chesed"
	desc$ = "Perfected work. Settlement. Completion after much labor. Rest. Sublety. Cleverness. Conclusions from previous knowledge. Ill-dignified: Unreliability from over anxiousness and hurriedness of action."
	desc2$ = "The wands are headed by rams and at the other end doves. The number four conveys the introduction of order into creation."
		
	Case 26 ; Strife
	tmp$ = tmp$ + "Five of Wands: Strife": astro$ = "Saturn in Leo": hebrew$ = "Geburah"
	desc$ = "Quarreling. Fighting. Competition. Cruelty. Violence. Lust and desire. May be prodigality or generosity according to dignity."
	desc2$ = "The wands are the Caduceus, the Phoenix and the Lotus. Their disproportionate size indicates that, following the coordination of spirit, disunion has begun."
	
	Case 27 ; Victory
	tmp$ = tmp$ + "Six of Wands: Victory": astro$ = "Jupiter in Leo": hebrew$ = "Tiphareth"
	desc$ = "Energy in balanced manifestation. Love. Gain and success. Triumph after strife. Ill-dignified: Insolence and pride."
	desc2$ = "Caduceus, Phoenix and Lotus wands are in arranged order, the warring and the peaceful opposites are balanced."
	
	Case 28 ; Valour
	tmp$ = tmp$ + "Seven of Wands: Valour": astro$ = "Mars in Leo": hebrew$ = "Netzach"
	desc$ = "Energy feels itself at last gasp. Struggles.  Possible victory.  Obstacles and difficulties yet courage to meet them. Victory in small things. Ill-dignified: Quarreling." 
	desc2$ = "The wands are covered by a club. Valour implies fear as well as courage."
	
	Case 29 ; Swiftness
	tmp$ = tmp$ + "Eight of Wands: Swiftness": astro$ = "Mercury in Sagittarius": hebrew$ = "Hod"
	desc$ = "Speech. Light. Electricity. Energy of high velocity. Activity. Approach to goal. Letter or message. Rapidity. Boldness. Freedom. Ill-dignified: Too much force applied too suddenly. A flash in the pan."
	desc2$ = "The wands have turned into electric energy, above is a rainbow. Here we have the acme of restless force."
	
	Case 30 ; Strength
	tmp$ = tmp$ + "Nine of Wands: Strength": astro$ = "Moon in Sagittarius": hebrew$ = "Yesod"
	desc$ = "Power. Health. Success after opposition and strife. Tremendous force. Recovery from sickness. Victory after apprehension and fear. Illustrates the aphorism that " + Chr$(34) + "change is stability" + Chr$(34) + "."
	desc2$ = "The small wands are the arrows of Diana, the master wand has the moon for its point and the sun for its base. This shows the combined swiftness and heat of fire."
	
	Case 31 ; Oppression
	tmp$ = tmp$ + "Ten of Wands: Oppression": astro$ = "Saturn in Sagittarius": hebrew$ = "Malkuth"
	desc$ = "Force detached from spiritual forces. Fire in its most destructive aspect. Cruelty and malice. Selfishness. Lying. Repression. Slander. Ill will. Can be self-sacrifice and generosity if particularly well-dignified."
	desc2$ = "Eight plain wand sticks, dominated by two dorjes lengthened into bars, show the slow smoldering of an exhausted force."

; //===============================================================================================
; // CUPS
; //===============================================================================================
	Case 36 ; Ace of Cups
	tmp$ = tmp$ + "Ace of Cups": astro$ = "": hebrew$ = ""
	desc$ = "The Root of the Powers of Water. Fertility. Productiveness, Beauty. Pleasure and happiness."
	desc2$ = "This is the heart of the element of water and love. It is the Holy Grail receiving the impress of divine inspiration."
	
	Case 37 ; Love
	tmp$ = tmp$ + "Two of Cups: Love": astro$ = "Venus in Cancer": hebrew$ = "Chokmah"
	desc$ = "Harmony of male and female interpreted in broadest sense. Perfect and placid harmony radiating intense joy and ecstasy. Pleasure. Warm friendship. Mirth. Ill-dignified: Folly. Dissipation. Waste."
	desc2$ = "Two overflowing cups filled from a lotus and twined with the dolphins of Venus. This is the harmonious union of male and female."
	
	Case 38 ; Abundance
	tmp$ = tmp$ + "Three of Cups: Abundance": astro$ = "Mercury in Cancer": hebrew$ = "Binah"
	desc$ = "Spiritual basis of fertility. Plenty. Hospitality. Pleasure. Sensuality. Passive success. Love. Kindness. Bounty. The good things of life, while they are to be enjoyed, are transient and therefore cannot be relied on."
	desc2$ = "The pomegranate cups are filled by wreathed lotuses to show the happy fruition of love."
	
	Case 39 ; Luxury
	tmp$ = tmp$ + "Four of Cups: Luxury": astro$ = "Moon in Cancer": hebrew$ = "Chesed"
	desc$ = "Weakness. Abandonment to desire. Pleasure mixed with anxiety. Blended success and pleasure possibly approaching their end. Injustice. The seeds of decay in fruits of pleasure."
	desc2$ = "The roughened surface of the sea on which the cups and the lotuses are balanced explains that an element of excess has entered into love."
	
	Case 40 ; Disappointment
	tmp$ = tmp$ + "Five of Cups: Disappointment": astro$ = "Mars in Scorpio": hebrew$ = "Geburah"
	desc$ = "End of pleasure. Disturbance when least expected. Misfortune. Disappointment in love. Unkindness from friends. Loss of friendship. Treachery. Ill will. Sadness. Vain regret."
	desc2$ = "The cups are arranged on the stalks of the lotus in an inverted pentagram. Love has lost its first glamour."
	
	Case 41 ; Pleasure
	tmp$ = tmp$ + "Six of Cups: Pleasure": astro$ = "Sun in Scorpio": hebrew$ = "Tiphareth"
	desc$ = "Well-being. Harmony of natural forces without effort or strain. Ease. Satisfaction. Happiness. Success. Fulfillment of sexual will. Beginning of steady increase (but beginning only). Ill-dignified: Vanity. Presumptuousness. Thanklessness."
	desc2$ = "The cups are full but do not overflow, here is love for personal gratification."
	
	Case 42 ; Debauch
	tmp$ = tmp$ + "Seven of Cups: Debauch": astro$ = "Venus in Scorpio": hebrew$ = "Netzach"
	desc$ = "Delusion. Illusory success. Drug addiction. Intoxication. Guilt. Lying. Deceit. Promises unfulfilled. Lust. Fornication. Dissipation in love and friendship. Vanity."
	desc2$ = "Here is effort to increase pleasure has ended in corruption. The lotuses have become poisonous and the cups are chipped."
	
	Case 43 ; Indolence
	tmp$ = tmp$ + "Eight of Cups: Indolence": astro$ = "Saturn in Pisces": hebrew$ = "Hod"
	desc$ = "Abandoned success. Decline of interest in anything. Temporary success but without further result. Instability. Misery and repining. Journeying from place to place. May mean leaving material success for something higher."
	desc2$ = "The power is now spent, the water is turned to slime, the flowers droop, the cups are broken."
	
	Case 44 ; Happiness
	tmp$ = tmp$ + "Nine of Cups: Happiness": astro$ = "Jupiter in Pisces": hebrew$ = "Yesod"
	desc$ = "Complete success. Pleasure and happiness. Physical well-being. Happiness almost perfect but perhaps temporary. Ill-dignified: Danger of vanity, self-praise, conceit and overindulgence."
	desc2$ = "The nine cups are perfectly arranged, they overflow but this is an ordered possessive aspect of love partaking of a ritual."
	
	Case 45 ; Satiety
	tmp$ = tmp$ + "Ten of Cups: Satiety": astro$ = "Mars in Pisces": hebrew$ = "Malkuth"
	desc$ = "Pursuit of pleasure crowned with perfect success but incomplete. Matters arranged and settled as wished. Lasting success. Peacemaking and generosity. Ill-dignified: Dissipation. Debauchery. Pity. Waste. Stagnation."
	desc2$ = "The cups are arranged on the Tree of Life and a great lotus overshadows them. Exhaustion, which comes from expended energy, is expressed."

; //===============================================================================================
; // SWORDS
; //===============================================================================================
	Case 50 ; Ace of Swords
	tmp$ = tmp$ + "Ace of Swords": astro$ = "": hebrew$ = ""
	desc$ = "The Root of the Powers of Air. Invoked force as contrasted with natural force (compare Ace of Wands). Represents great power for good or evil but invoked. Conquest. Whirling force. Activity. Strength through trouble. As affirmation of justice upholding divine authority, may become sword of wrath, punishment and affliction."
	desc2$ = "This card is a picture of the intellect in its best and most controlled aspect. On the hilt of the sword is written Thelema or will. There are two moons and three suns on the handle, the expanse of sky behind it suggests the other meaning of the suit, the element of air."
	
	Case 51 ; Peace
	tmp$ = tmp$ + "Two of Swords: Peace": astro$ = "Moon in Libra": hebrew$ = "Chokmah"
	desc$ = "Contradictory characteristics in the same nature. Sacrifice and trouble giving birth to strength. Quarrel made up and peace restored, yet tension remaining. Pleasure after pain. Truth and untruth. Indecision. Actions sometimes selfish, sometimes unselfish."
	desc2$ = "The two swords piercing a rose or lotus shows, in the symbol, the intellect restrained by love."
	
	Case 52 ; Sorrow
	tmp$ = tmp$ + "Three of Swords: Sorrow": astro$ = "Saturn in Libra": hebrew$ = "Binah"
	desc$ = "Melancholy. Unhappiness. Tears. Disruption. Sowing of discord and strife. Delay. Absence. Separation. Mirth in forbidden pleasures. Deceit. Well-dignified: Singing. Faithfulness in promises. Honesty in money transactions."
	desc2$ = "A magician's sword and two short ones are tearing the rose to pieces. This suggests the confusion and darkness of the intellect which is emancipated without a guiding principle."
	
	Case 53 ; Truce
	tmp$ = tmp$ + "Four of Swords: Truce": astro$ = "Jupiter in Libra": hebrew$ = "Chesed"
	desc$ = "Rest from sorrow. Peace after war. Relaxation of anxiety. Refuge from mental chaos. Recovery from sickness. Change for the better after struggle. Authority in the intellectual world. Convention. Establishment of dogma."
	desc2$ = "The formality of the design of the swords, the cross, and the rose denote intellect bound by rigid convention. The surrounding crystals, as in all these sword cards, contain the hidden names of their guardian angels worked out in numbers on squared paper. It was thought that air was formed of crystals according to Pythagoras."
	
	Case 54 ; Defeat
	tmp$ = tmp$ + "Five of Swords: Defeat": astro$ = "Venus in Aquarius": hebrew$ = "Geburah"
	desc$ = "Loss. Malice. Spite. Weakness. Slander. Failure. Anxiety. Poverty. Dishonor. Trouble. Grieving after pain. Ties. Separator of friends. A busybody. Cruel yet cowardly, evil speaking."
	desc2$ = "The swords form an inverted pentagram. They are crooked and broken and the roses are falling. The condition shown is intellect weakened by sentiment."
	
	Case 55 ; Science
	tmp$ = tmp$ + "Six of Swords: Science": astro$ = "Mercury in Aquarius": hebrew$ = "Tiphareth"
	desc$ = "Intelligence that has realized its goal. Labor. Work. Success after anxiety. Passage from difficulty. Journey by water. Ill-dignified: Selfishness. Conceit. Intellectual pride."
	desc2$ = "The points of the swords centre in a rose and cross. They are lying on a fencer's diagram (14th century) which was worked out scientifically to show the positions in which a fencer can stand and be invulnerable. The card suggests by its symmetrical design a perfect balance of intellect and principle."
	
	Case 56 ; Futility
	tmp$ = tmp$ + "Seven of Swords: Futility": astro$ = "Moon in Aquarius": hebrew$ = "Netzach"
	desc$ = "Unstable effort. Vacillation. Vain striving against opposition too powerful. Partial success by giving up on the brink of winning through lack of energy. Fascination with display. Journey by land. Untrustworthy person."
	desc2$ = "The hilts of the swords form a crescent, but the card is a tenuous design to show that a mind is confused and undecided."
	
	Case 57 ; Interference
	tmp$ = tmp$ + "Eight of Swords: Interference": astro$ = "Jupiter in Gemini": hebrew$ = "Hod"
	desc$ = "Waste of energy in details causing neglect of more important things. Lack of persistence. Sheer, unseen back luck. Restriction. Great care in some things counterbalanced by equal disorder in others."
	desc2$ = "The arrangement of these Indian swords covered by two long ones tells of outside obstruction and consequent inability to concentrate the mind."
	
	Case 58 ; Cruelty
	tmp$ = tmp$ + "Nine of Swords: Cruelty": astro$ = "Mars in Gemini": hebrew$ = "Yesod"
	desc$ = "Agony of mind. Despair. Hopelessness. Worry. Suffering. Loss. Illness. Malice. Pain. Burden. Oppression. Subtlety and craft. Lying. Shame. Well-dignified: Obedience. Faithfulness. Patience. Unselfishness."
	desc2$ = "These jagged swords are dropping blood and tears, and represent mind dominated by insatiable desires."
	
	Case 59 ; Ruin
	tmp$ = tmp$ + "Ruin": astro$ = "Sun in Gemini": hebrew$ = "Malkuth"
	desc$ = "Reason divorced from reality. Death. Failure. Disaster yet not entirely without hope. Disruption. Idle chatter. Clever, eloquent and insolent person, impertinent yet with mirth. Spiritually, may herald the end of delusion."
	desc2$ = "Again the design is the Tree of Life on which the swords are arranged. The centre one is the heart or sun which is broken into fragments. The mind has let go all control and whirls in tormented madness."

; //===============================================================================================
; // DISKS
; //===============================================================================================	
	Case 64 ; Ace of Disks
	tmp$ = tmp$ + "Ace of Disks": astro$ = "": hebrew$ = ""
	desc$ = "The Root of the Powers of Earth. Material gain. Power. Labor. Wealth. Contentment. Materiality in all senses. For Crowley, this card was an affirmation of the identity of the sun and earth, spirit and flesh."
	desc2$ = "This is primitive earth, both as a whirling planet and a substance. The movement of the planet is suggested by the wings. The Greek inscription is " + Chr$(34) + "to the mark of the Beast" + Chr$(34) + " and implies the earthy element."
	
	Case 65 ; Change
	tmp$ = tmp$ + "Change": astro$ = "Jupiter in Capricornus": hebrew$ = "Chokmak"
	desc$ = "Harmony of change. Alternation of gain and loss, weakness and strength, elation and melancholy. Varying occupation. Wandering. Visit to friends. Pleasant change. Industrious yet unreliable person."
	desc2$ = "Here are two pentacles, the Chinese Yang and Yin. The crowned serpent surrounds them as they revolve. The card suggests that the universe is sustained in space by its rotating action."
	
	Case 66 ; Works
	tmp$ = tmp$ + "Works": astro$ = "Mars in Capricornus": hebrew$ = "Binah"
	desc$ = "Business. Paid employment. Commercial transaction. Constructive building up. Increase of material things. Growth. Commencement of matters to be establishment later. Ill-dignified: Selfish, narrow, prejudiced, greedy person seeking impossibilities."
	desc2$ = "A three-dimensional pyramid is looked at from above. It is placed on three wheels on which are the signs for mercury, sulphur and salt, a fundamental analysis of the components of earch according to the alchemists."
	
	Case 67 ; Power
	tmp$ = tmp$ + "Power": astro$ = "Sun in Capricornus": hebrew$ = "Chesed"
	desc$ = "Law and order. Gain of money and influence. Earthly power but nothing beyond. Success. Rank. Dominion. Skill in the direction of physical forces. Ill-dignified: Prejudice. Covetousness. Suspicion. Lack of originality."
	desc2$ = "Four square disks engraved with the signs of the elements form the towers of a fortress surrounded by a moat. The design is intended to show the perfect government of the universe by law and order."
	
	Case 68 ; Worry
	tmp$ = tmp$ + "Worry": astro$ = "Mercury in Taurus": hebrew$ = "Geburah"
	desc$ = "Intense strain with continued inaction. Loss of money. Profession. Monetary anxiety. Poverty. Well-dignified: Labor. Land cultivation. Building. Intelligence applied to labor."
	desc2$ = "Five disks in an inverted pentagram. They are surrounded by other disks which are bent and torn by strain. The picture shows suppressed action and the binding of celestial forces to mechanical purposes."
	
	Case 69 ; Success
	tmp$ = tmp$ + "Success": astro$ = "Moon in Taurus": hebrew$ = "Tiphareth"
	desc$ = "Success and gain in material things. Power. Influence. Nobility. Philanthropy. Somewhat dreamy and transitory situation. Ill-dignified: Insolence. Conceit with wealth. Prodigality."
	desc2$ = "The disks form a hexagram and represent the seven plants with the sun in the centre as a rose and cross. These indicate the harmonious movement of the spheres."
	
	Case 70 ; Failure
	tmp$ = tmp$ + "Failure": astro$ = "Saturn in Taurus": hebrew$ = "Netzach"
	desc$ = "Labor abandoned. Sloth. Unprofitable speculation. Promises of success unfulfilled. Hopes deceived. Disappointment. Little gain from much labor. Well-dignified: Delay but growth. Honorable work undertaken for the love of work with no expectation of material gain."
	desc2$ = "The disks are in the geomantic figure Rubeus. They now represent only the one planet Each and are engraved with the sign of Aries and Saturn. The conception suggests the binding conditions of earthly life."
	
	Case 71 ; Prudence
	tmp$ = tmp$ + "Prudence": astro$ = "Sun in Virgo": hebrew$ = "Hod"
	desc$ = "Intelligence applied to material affairs. Agriculture. Building. Skill. Cunning. Industriousness. Ill-dignified: Penny wise and pound foolish attitudes. Avariciousness and hoarding. Meanness. Over-carefulness in small things at the expense of the great."
	desc2$ = "The geomantic figure Populus forms the positions of the disks which appear as flowers on a great tree protected by the leaves. The possession of the fruits of the earth brings its own responsibility."
	
	Case 72 ; Gain
	tmp$ = tmp$ + "Gain": astro$ = "Venus in Virgo": hebrew$ = "Yesod"
	desc$ = "Good luck attending material affairs. Inheritance. Great increase in wealth. Completion of material gain. Ill-dignified: Covetousness. Theft. Knavery."
	desc2$ = "Six disks stamped with the pictures of the deities of the planets form two equilateral triangles and the remaining three are interlaced in the middle. These with their beams of light show a condition in which chance and management give an increasing good fortune."
	
	Case 73 ; Wealth
	tmp$ = tmp$ + "Wealth": astro$ = "Mercury in Virgo": hebrew$ = "Malkuth"
	desc$ = "Material prosperity and riches. Completion of material fortune but nothing beyond final solidification unless there is devotion to creativity. Old age. Ill-dignified: Slothfulness. May mean partial loss, dullness of mind with acuity and profit in money transactions. Heaviness."
	desc2$ = "The disks have now definitely become coins and arranged on the Tree of Life. They are stamped with different renderings of the signs of Mercury. This mercurial signature is intended to show that though they appear solid, they are, in reality, fugitive."
	
; //===============================================================================================
; // COURT CARDS
; //===============================================================================================
	Case 32 ; Princess of Wands
	tmp$ = tmp$ + "Princess of Wands": astro$ = "": hebrew$ = ""
	desc$ = "Represents the earthy part of fire. A young woman, individualistic, brilliant and daring with great energy, sudden and violent in love or anger, enthusiastic. Ill-dignified: Superficial, theatrical, shallow, false, cruel, unreliable, faithless, domineering woman."
	desc2$ = "The material aspect of fire is suggested, such as creeping flames liable to burst into a violent conflagration."
	
	Case 33 ; Prince of Wands
	tmp$ = tmp$ + "Prince of Wands": astro$ = "": hebrew$ = ""
	desc$ = "Represents the airy part of fire. A young man, swift and strong, impulsive, violent, just, noble and generous with a sense of humor. Ill-dignified: Proud, intolerant, cruel and prejudiced youth who may be a coward."
	desc2$ = "Here is shown the airy quality of fire, smoke and expansion."
	
	Case 34 ; Queen of Wands
	tmp$ = tmp$ + "Queen of Wands": astro$ = "": hebrew$ = ""
	desc$ = "Represents the watery part of fire. A woman of adaptability, persistent energy, calm authority, with great power to attract, generous but impatient of opposition. Ill-dignified: A woman who is stupid, obstinate, revengeful, domineering, quick to take offense without good cause."
	desc2$ = "This represents the receptivity of fire, its movement and colour."
	
	Case 35 ; Knight of Wands"
	tmp$ = tmp$ + "Knight of Wands": astro$ = "": hebrew$ = ""
	desc$ = "Represents the fiery part of fire. A man with the qualities of activity, generosity, impetuosity, pride and swiftness. Ill-dignified: Evil-minded, cruel, bigoted and brutal man."
	desc2$ = "This is the purely male creative force in fire or spirit."

	Case 46 ; Princess of Cups
	tmp$ = tmp$ + "Princess of Cups": astro$ = "": hebrew$ = ""
	desc$ = "Represents the earthy part of Water. A young woman, infinitely gracious, all sweetness voluptuousness, gentleness, kindness, romantic and dreamy; if ill-dignified, indolent, selfish and concerned with her own personal luxury."
	desc2$ = "Here is snow. Round the princess's dress are water crystals, beside her is a dolphin of Venus; the tortoise is an emblem of earth to show the solidification of water in mud, ice and snow."
	
	Case 47 ; Prince of Cups
	tmp$ = tmp$ + "Prince of Cups": astro$ = "": hebrew$ = ""
	desc$ = "Represents the airy part of Water. A young man whose characteristics are subtlety, secret violence, craft, an artist, calm on the surface masking intense passion, cares intensely for power, wisdom, and his own aims, ruthless. If badly dignified, can be intensely evil and merciless with overweening ambition."
	desc2$ = "This card shows elasticity or steam of water. He is seated in a Chariot surrounded by vapour and drawn by an eagle to suggest a volatile aerated element."
	
	Case 48 ; Queen of Cups
	tmp$ = tmp$ + "Queen of Cups": astro$ = "": hebrew$ = ""
	desc$ = "Represents the watery part of Water. A woman who reflects the nature of an observer, dreamy, tranquil,postic, imaginative, kind yet not willing to take much trouble for another. She is much affected by surrounding influences, the outward becomes very much the inward, so this card is heavily influenced by the dignity of surrounding cards."
	desc2$ = "This is the passive and receptive quality of water. She is almost invisible as she is enveloped by shadowy reflections."
	
	Case 49 ; Knight of Cups
	tmp$ = tmp$ + "Knight of Cups": astro$ = "": hebrew$ = ""
	desc$ = "Represents the fiery part of Water. A man who is a graceful dilettante, amiable in a passive way, quick to respond to attraction and easily enthusiastic, exceedingly sensitive but little depth of character. If ill-dignified, sensual and idle, untruthful, prone to melancholy and drug abuse."
	desc2$ = "He is the strength and energy of water, the ocean. The peacock in the waves stands for brilliance, the crab for the aggression of the flood."
		
	Case 60 ; Princess of Swords
	tmp$ = tmp$ + "Princess of Swords": astro$ = "": hebrew$ = ""
	desc$ = "Represents the earthy part of Air. A young woman, stern and revengeful with destructive logic, firm and aggressive with great practical wisdom and subtlety, dexetrous in management of practical affairs. If ill-dignified, filled with low cunning and frivolousness."
	desc2$ = "This is air in the earth, the oxygen which promotes the growth of plants and the warlike rush of the figure of the princess is the incarnation of dynamic irruption."
	
	Case 61 ; Prince of Swords
	tmp$ = tmp$ + "Prince of Swords": astro$ = "": hebrew$ = ""
	desc$ = "Represents the airy part of Air. A young man purely intellectual, full of ideas and designs, intensely clever but unstable of purpose, an elusive and elastic mind supporting various and contradictory opinions, domineering. He slays as fast as he creates. If badly dignified, may be harsh, malicious, and unreliable, a fanatic."
	desc2$ = "The prince conveys two ideas, one simply hail, the other the restriction of the scientific outlook, which uses but limits the imagination which is shown in the harnessed fays."
	
	Case 62 ; Queen of Swords
	tmp$ = tmp$ + "Queen of Swords": astro$ = "": hebrew$ = ""
	desc$ = "Represents the watery part of Air. A graceful woman, intensely perceptive, a keen observer, subtle interpreter, an intense individualist, confident, gracious and just. If ill-dignified, cruel, sly and deceitful, unreliable, yet superbly attractive, making her all the more dangerous."
	desc2$ = "The placing of the cruel queen on columns of clouds is intended to suggest rain and the consequent darkening of the skies."
	
	Case 63 ; Knight of Swords
	tmp$ = tmp$ + "Knight of Swords": astro$ = "": hebrew$ = ""
	desc$ = "Represents the fiery part of Air. A man, active skillful and clever, fierce,delicate and courageous, but often unreflective. If ill-dignified, he is incapable of decision,deceiful, tyrannical and crafty."
	desc2$ = "Dashing through the air this knight embodies all the winds of heaven."

	Case 74 ; Princess of Disks
	tmp$ = tmp$ + "Princess of Disks": astro$ = "": hebrew$ = ""
	desc$ = "Represents the earthy part of Earth. A young woman, beautiful and strong, generous, diligent and kind. If badly dignified, she is wasteful and cruel, selfish with her energies."
	desc2$ = "Here we have an attempt to translate into a picture the spiritual quality of earth, eternally pregnant and containing in its fertility the unwritten cypher of cosmic lore."
	
	Case 75 ; Prince of Disks
	tmp$ = tmp$ + "Prince of Disks": astro$ = "": hebrew$ = ""
	desc$ = "Represents the airy part of Earth. A young man who is energetic and steadfast worker, a capable manager, competent but resentful of spiritual types, slow to anger but implacable if aroused."
	desc2$ = "The prince in a chariot, drives an impetuous bull, he is a symbol of the fruits and seeds of earth."
	
	Case 76 ; Queen of Disks
	tmp$ = tmp$ + "Queen of Disks": astro$ = "": hebrew$ = ""
	desc$ = "Represents the watery part of Earth. A woman who is wise in practical matters, affectionate, kind-hearted and somewhat timid, but charming. If ill-dignified, can be servile and dull, prone to moodiness."
	desc2$ = "Every symbol in this picture suggests the fertility and warmth of earth."
	
	Case 77 ; Knight of Disks
	tmp$ = tmp$ + "Knight of Disks": astro$ = "": hebrew$ = ""
	desc$ = "Represents the fiery part of Earth. A patient man, painstaking and wise in material things, sometimes considered dull and preoccupied with earthly matters. Can be greedy and grasping, surly or jealous if badly dignified."
	desc2$ = "The knight is being drawn into the soil. He represents the generative property of earth."

End Select	

Desk_W = ClientWidth(Desktop()): Desk_H = ClientHeight(Desktop())
zWin(zWinCount) = CreateWindow(tmp$, Desk_W / 2 - 205, Desk_H / 2 - 171, 412, 344, winTool, 1 + 2)
hWnd = QueryObject(zWin(zWinCount), 1)
icon = LoadIcon(hWnd, "icon.ico", 0)
SetClassLong hWnd, -14, icon

tarea = CreateTextArea(203, 0, 201, 317, zWin(zWinCount), 1)
LockTextArea tarea
SetGadgetLayout tarea, 2, 1, 2, 1
Font = LoadFont("ChessMasterX", 20, 0, 0, 0)
SetTextAreaFont tarea, Font ; RequestFont()
SetTextAreaColor tarea, 0, 0, 0, 1
SetTextAreaColor tarea, 255, 255, 255, 0
If astro$ = "" Or hebrew$ = "" Then
	SetTextAreaText tarea, desc$ + Chr$(10) + Chr$(10) + desc2$
Else
	SetTextAreaText tarea, astro$ + ". " + hebrew$ + "." + Chr$(10) + Chr$(10) + desc$ + Chr$(10) + Chr$(10) + desc2$
EndIf
UnlockTextArea tarea
SendMessage QueryObject(tarea, 1), $CF, 1, 1 ; Lock 

tmpPanel = CreatePanel(99 - ImageWidth(itmp) / 2, 157 - ImageHeight(itmp) / 2, ImageWidth(itmp) + 4, ImageHeight(itmp) + 4, zWin(zWinCount), -1)
SetGadgetLayout tmpPanel, 2, 2, 2, 2

; Canvas
zCanvas = CreateCanvas(0, 0, ImageWidth(itmp), ImageHeight(itmp), tmpPanel)
SetGadgetLayout zCanvas, 2, 2, 2, 2
SetBuffer CanvasBuffer(zCanvas); HidePointer zCanvas
If rev = True Then HandleImage itmp, ImageWidth(itmp), ImageHeight(itmp): RotateImage itmp, 180
DrawImage itmp, 0, 0
FlipCanvas zCanvas, 0
FreeImage itmp

SetBuffer CanvasBuffer(Canvas)
;DebugLog CardWinX + " | " + CardWinY + " | " + CardWinW + " | " + CardWinH
If CardWinX + CardWinY + CardWinW + CardWinH <> 0 Then ; Restore Window Position
	SetWindowPos QueryObject(zWin(zWinCount), 1), 0, CardWinX, CardWinY, CardWinW, CardWinH, 4 + 64
EndIf
End Function

; Handles clicks to cards and Z Order
Function CheckCard()
If bDrag = True Then Return ; Exit when dragging

tmpN = -1
For c.Card = Each Card
	If ImageRectCollide(iBack, c\X, c\Y, 0, MouseX(Canvas) + xScr, MouseY(Canvas) + yScr, 1, 1) Then
		If c\N > tmpN Then tmpN = c\N
	EndIf
Next
If tmpN = -1 Then Return ; None clicked

For c.Card = Each Card   ; Enact action upon top card
	If c\N = tmpN        ; Top card
		If c\D = 0 Then  ; Flip		
			itmp = LoadImage("gfx/" + c\F + ".jpg"): MaskImage itmp, 255, 0, 255
			tmp = CopyImage(itmp)
			If MenuChecked(mnuLarge) Then ; Large Card
				ResizeImage tmp, 89, 140
			Else                          ; Small Card
				ResizeImage tmp, 71, 96
			EndIf
			
			If MenuChecked(mnuRev) Then ; Reverse
				If Rand(1, 4) = 1 Then 
					HandleImage tmp, ImageWidth(tmp), ImageHeight(tmp): RotateImage tmp, 180
					c\Rev = True
				Else
					c\Rev = False
				EndIf
			EndIf

			c\RC = CopyImage(tmp)
			FreeImage itmp: FreeImage tmp	
			c\D = 1: MH2 = False
			Return 
		Else             ; Zoom
			LoadWindow c\N, c\F, c\Rev: MH2 = False
			zWinCount = zWinCount + 1
			If zWinCount >= 77 Then zWinCount = 0
			Return
		EndIf
	EndIf
Next	

End Function

Function SetStyle(win)
hWnd = QueryObject(win, 1)
icon = LoadIcon(hWnd, "icon.ico", 0)
SetClassLong hWnd, -14, icon
ret = GetWindowLong(hWnd, -16)
ret = ret Or $20000
SetWindowLong hWnd, -16, ret

UpdateWindowMenu win
End Function

Function ChangeDeck(n)
FreeImage iBack
iBack = LoadImage("gfx/back" + Str(n) + ".png"): MaskImage iBack, 255, 0, 255
If MenuChecked(mnuSmall) Then ResizeImage iBack, 71, 96
	
End Function

Function LoadGUI(n)
Desk_W = ClientWidth(Desktop()): Desk_H = ClientHeight(Desktop())
Font = LoadFont("Courier New", 16, 1, 0, 0)

Select n
	Case 1 ; Parent
	AppTitle "Tarot"
	Parent = CreateWindow("Tarot", Desk_W / 2 - 325, Desk_H / 2 - 264, 650, 528, 0, 1 + 4)
	SetMinWindowSize Parent, 650, 528
	SetStyle Parent

	winTool = CreateWindow("", 0, 0, 0, 0, Parent, 16)
	HideGadget winTool

	Menu = WindowMenu(Parent) 
	Game = CreateMenu("Game", 0, Menu)
	CreateMenu "Shuffle", cntCP, Game
	CreateMenu "", 0, Game
	mnuRev = CreateMenu("Reversals", cntREV, Game)
	;CheckMenu mnuRev
	CreateMenu "Table", cntBACK, Game
	CreateMenu "Deck", cntDECK, Game
	CreateMenu "", 0, Game
	CreateMenu "Exit", cntEXIT, Game
	View = CreateMenu("View", 0, Menu)
	mnuMax = CreateMenu("Maximized", cntMAX, View)
	mnuSize = CreateMenu("Card Size", 0, View)
	mnuSmall = CreateMenu("Small", cntSMALL, mnuSize)
	mnuLarge = CreateMenu("Large", cntLARGE, mnuSize)
	;CheckMenu mnuLarge
	mnuNum = CreateMenu("Card Number", cntNUM, View)
	;CheckMenu mnuNum
	mnuInfo = CreateMenu("Debug Info", cntCNT, View)
	;CheckMenu mnuInfo
	mnuWins = CreateMenu("Windows", cntWIN, Menu)
	CreateMenu "Home", cntHOME, mnuWins
	CreateMenu "Notes", cntNOTE, mnuWins
	CreateMenu "Book of Thoth", cntBOOK, mnuWins
	
	Help = CreateMenu("Help", 0, Menu)
	CreateMenu "Instructions", cntINSTR, Help
	CreateMenu "About", cntABOUT, Help
	UpdateWindowMenu Parent
	
	; Sunken Panel (nicer canvas look)
	Panel = CreatePanel(0, 0, 644, 484, Parent, -1)
	
	; Canvas
	Canvas = CreateCanvas(0, 0, 640, 480, Panel)
	SetBuffer CanvasBuffer(Canvas): ClsColor TableCol1, TableCol2, TableCol3 ; Color

	Case 4 ; Deck Window
	winDeck = CreateWindow("Select Card Back", Desk_W /2 - 105, Desk_H /2 - 133, 210, 266, winTool, 1)
	bDeckOK = CreateButton("OK", 70, 213, 64, 24, winDeck)
	SetGadgetFont bDeckOK, Font
	
	tmpX = 5: tmpY = 5
	For i = 0 To 14
		BackPanel(i) = CreatePanel(tmpX, tmpY, 33, 62, winDeck, 0)
		tmpImg = LoadImage("gfx/back" + Str(i + 1) + ".png"): MaskImage tmpImg, 255, 0, 255
		ResizeImage tmpImg, 33, 62: SaveImage tmpImg, "gfx/tmp.bmp": FreeImage tmpImg
		SetPanelImage BackPanel(i), "gfx/tmp.bmp"
		DeleteFile "gfx/tmp.bmp"
		tmpX = tmpX + 40
		If tmpX >= 200 Then tmpX = 5: tmpY = tmpY + 70
	Next

	Case 5 ; Browser
	winHome = CreateWindow("Tarot Browser", ClientWidth(Desktop())/2-326, ClientHeight(Desktop())/2-265, 652, 530, Parent, 1 + 2 + 8)
	gadBrowse = CreateHtmlView(1, 27, 643, 455, winHome)           ; Browser
	btnBack = CreateButton("< Back", 3, 3, 60, 21, winHome, 1)    ; Back Button
	btnFor = CreateButton("Forward >", 64, 3, 60, 21, winHome, 1) ; Forward Button
	btnHome = CreateButton("Home", 125, 3, 60, 21, winHome, 1)    ; Home Button
	
	SetGadgetLayout gadBrowse, 1, 2, 1, 2
	SetGadgetLayout btnBack, 1, 2, 1, 0
	SetGadgetLayout btnFor, 2, 2, 1, 0
	SetGadgetLayout btnHome, 2, 2, 1, 0 
		
	HtmlViewGo gadBrowse, "http://www.eiksoft.com"
	SetStatusText winHome, " Welcome to the Eiksoft homepage"
	SetMinWindowSize winHome, 652, 530

	SetGadgetShape winHome, 0, 0, ClientWidth(Desktop()), ClientHeight(Desktop())
	
	Case 6 ; Book of Thoth
	winHome = CreateWindow("Book of Thoth", ClientWidth(Desktop())/2-326, ClientHeight(Desktop())/2-265, 652, 530, Parent, 1 + 2 + 8)
	gadBrowse = CreateHtmlView(1, 27, 643, 455, winHome)          ; Browser
	btnPrevP = CreateButton("< Prev Page", 3, 3, 90, 21, winHome, 1)    ; Back Button
	btnNextP = CreateButton("Next Page >", 94, 3, 90, 21, winHome, 1) ; Forward Button
	btnHome = CreateButton("Home", 184, 3, 60, 21, winHome, 1)    ; Home Button
	
	SetGadgetLayout gadBrowse, 1, 2, 1, 2
	SetGadgetLayout btnPrevP, 1, 2, 1, 0
	SetGadgetLayout btnNextP, 2, 2, 1, 0
	SetGadgetLayout btnHome, 2, 2, 1, 0 
		
	botPage = 1		
	HtmlViewGo gadBrowse, CurrentDir$() + "htm/page1.htm"
	SetStatusText winHome, " Book of Thoth page " + botPage
	SetMinWindowSize winHome, 652, 530

	Case 7 ; Notes
	winNotes = CreateWindow("Tarot Notes", ClientWidth(Desktop())/2-326, ClientHeight(Desktop())/2-265, 652, 530, Parent, 1 + 2)
	NoteArea = CreateTextArea(-1, 0, 646, 504, winNotes, 1)
	LockTextArea NoteArea
	SetGadgetLayout NoteArea, 1, 2, 1, 2
	Font = LoadFont("ChessMasterX", 20, 0, 0, 0)
	SetTextAreaFont NoteArea, Font ; RequestFont()
	SetTextAreaColor NoteArea, 0, 0, 0, 1
	SetTextAreaColor NoteArea, 255, 255, 255, 0
	SetTextAreaText NoteArea, cfgNotes$
	UnlockTextArea NoteArea
	
End Select
End Function

Function LoadCFG()
File = ReadFile("user.cfg")

tmp = ReadByte(File) ; Max
If tmp <> 0 Then 
	FreeGadget Panel
	SetWindowPos QueryObject(Parent, 1), 0, 0, 0, ClientWidth(Desktop()), ClientHeight(Desktop()) - 28, 4 + 64
	Canvas = CreateCanvas(0, 0, GadgetWidth(Parent) - 6, GadgetHeight(Parent) - 44, Parent)
	SetBuffer CanvasBuffer(Canvas): CheckMenu mnuMax
EndIf

DeckNumber = ReadByte(File) ; Deck Number
	
tmp = ReadByte(File) ; Small
If tmp <> 0 Then CheckMenu mnuSmall: DeckOX = 82: DeckOY = 106

tmp = ReadByte(File) ; Large
If tmp <> 0 Then CheckMenu mnuLarge: DeckOX = 100: DeckOY = 150

tmp = ReadByte(File) ; Reversals
If tmp <> 0 Then CheckMenu mnuRev

TableCol1 = ReadByte(File)
TableCol2 = ReadByte(File)
TableCol3 = ReadByte(File)
ClsColor TableCol1, TableCol2, TableCol3

tmp = ReadByte(File) ; Card Info
If tmp <> 0 Then CheckMenu mnuNum
cfgCardNum = tmp	
tmp = ReadByte(File) ; Debug Info
If tmp <> 0 Then CheckMenu mnuInfo

CardWinX = ReadInt(File) ; Card Window X
CardWinY = ReadInt(File) ; Card Window Y
CardWinW = ReadInt(File) ; Card Window W
CardWinH = ReadInt(File) ; Card Window H

cfgNotes$ = ReadString(File) ; Notes

CloseFile File	
UpdateWindowMenu Parent
End Function

Function SaveCFG()
File = WriteFile("user.cfg")

WriteByte File, MenuChecked(mnuMax)   ; Maximized
WriteByte File, DeckNumber            ; Deck Number
WriteByte File, MenuChecked(mnuSmall) ; Small Card
WriteByte File, MenuChecked(mnuLarge) ; Large Card
WriteByte File, MenuChecked(mnuRev)   ; Reversals
WriteByte File, TableCol1             ; Table Red
WriteByte File, TableCol2             ; Table Green
WriteByte File, TableCol3             ; Table Blue
WriteByte File, MenuChecked(mnuNum)   ; Card Info
WriteByte File, MenuChecked(mnuInfo)  ; Debug Info

;DebugLog CardWinX + " | " + CardWinY + " | " + CardWinW + " | " + CardWinH
WriteInt File, CardWinX             ; Card Window X
WriteInt File, CardWinY             ; Card Window Y
WriteInt File, CardWinW             ; Card Window W
WriteInt File, CardWinH             ; Card Window H
WriteString File, cfgNotes$           ; Notes

CloseFile File
End Function
	
Function ShuffleDeck()
For i = 0 To 77 ; Shuffle
	.Again
	Num = Rand(0, 77)
    For i2 = 1 To i - 1
		If DeckNum(i2) = Num Then Goto Again ; Already chosen
    Next
    DeckNum(i) = Num ; Number is new
Next
End Function	